<?php

/**
 * @file
 * Hooks and callback functions for rules.module integration.
 * 
 */

/**
 * Implements hook_rules_action_info().
 *
 * @ingroup rules
 */
function user_notifications_extras_rules_action_info() {
  return array(
    'rules_action_user_notifications_extras_notify_comment_thread' => array(
      'label' => t('Send a new notification to all users in a comment thread (comment module)'),
      'arguments' => array(
        'comment' => array('type' => 'comment', 'label' => t('Published Comment')),
        'actor' => array('type' => 'string', 'label' => t('Actor UID'), 'description' => t("The userID of the user who triggered the notfication, the actor. Use PHP evaluation or tokens to find the actor UID.")),
        'subject' => array('type' => 'string', 'label' => t('Subject')),
        'body' => array('type' => 'string', 'label' => t('Body text'), 'long' => TRUE),
        'tag' => array('type' => 'string', 'label' => t('Tag'), 'description' => t('Unique identifier tag for this message. ie. status_like or node_comment')),
      ),
      'module' => 'User Notifications',
    ),
    'rules_action_user_notifications_extras_notify_nodecomment_thread' => array(
      'label' => t('Send a new notification to all users in a node comment thread (node comment module)'),
      'arguments' => array(
        'comment' => array('type' => 'node', 'label' => t('Published Comment (nodecomment node)')),
        'actor' => array('type' => 'string', 'label' => t('Actor UID'), 'description' => t("The userID of the user who triggered the notfication, the actor. Use PHP evaluation or tokens to find the actor UID.")),
        'subject' => array('type' => 'string', 'label' => t('Subject')),
        'body' => array('type' => 'string', 'label' => t('Body text'), 'long' => TRUE),
        'tag' => array('type' => 'string', 'label' => t('Tag'), 'description' => t('Unique identifier tag for this message. ie. status_like or node_comment')),
      ),
      'module' => 'User Notifications',
    ),    
  );
}

/**
 * Rules action function for rules_action_user_notifications_extras_notify_comment_thread action
 */
function rules_action_user_notifications_extras_notify_comment_thread($comment, $actor_uid, $subject, $body, $tag, $settings = array()) {
  $recipient_uids = user_notifications_extras_notify_comment_thread_recipients($comment, $settings);
  $recipients = user_notifications_recipients_load($recipient_uids);
  user_notifications_new_notification_wrapper($recipients, $actor_uid, $subject, $body, $tag, $settings);
}

/**
 * Rules settings form for rules_action_user_notifications_extras_notify_comment_thread action
 */
function rules_action_user_notifications_extras_notify_comment_thread_form($settings = array(), &$form) {
  user_notifications_common_rules_form($settings, $form);
  user_notifications_extras_notify_comment_thread_form($settings, $form);
}

/**
 * Rules action function for rules_action_user_notifications_extras_notify_nodecomment_thread action
 */
function rules_action_user_notifications_extras_notify_nodecomment_thread($comment, $actor_uid, $subject, $body, $tag, $settings = array()) {
  $recipient_uids = user_notifications_extras_notify_comment_thread_recipients($comment, $settings, 'nodecomment');
  $recipients = user_notifications_recipients_load($recipient_uids);
  user_notifications_new_notification_wrapper($recipients, $actor_uid, $subject, $body, $tag, $settings);
}

/**
 * Rules settings form for rules_action_user_notifications_extras_notify_cnodeomment_thread action
 */
function rules_action_user_notifications_extras_notify_nodecomment_thread_form($settings = array(), &$form) {
  user_notifications_common_rules_form($settings, $form);
  user_notifications_extras_notify_comment_thread_form($settings, $form);
}