<?php
// $Id$

/**
 * @file
 * Menu callbacks
 */

/**
 * List notifications
 *
 * @TODO 
 * - Help me group the results in the query
 * - Output RSS feed functionality
 */
function user_notifications_list_page($feed = FALSE) {
  global $user, $base_url, $language;

  $account = $user;
	$result = user_notifications_display_query($account);
	$headers = array();
	while ($notification = db_fetch_object($result)) {
		if (!$feed) {
			$header = theme('user_notifications_date_header', $notification->timestamp);
			$row = '';
			if (empty($headers[$header])) {
				$row = $header;
				$headers[$header] = $header;
			}
			$row .= theme('user_notifications_row', $notification, 'page');
			$rows[] = $row;
			$notifications[$notification->nid] = $notification;
		}
		else {
			//feed extras
			$notification->feed_args = array(
				array(
					'key' => 'pubDate', 
					'value' => gmdate('r', $notification->timestamp)
				),
			);
			//pass to theme function
			$items .= theme('user_notifications_row_feed', $notification);
		}
	}
	
	$feed_title = t('Your @site_name Notifications', array('@site_name' => variable_get('site_name', 'Drupal')));
	//attach feed to page if not already active
	if (!$feed) {
	  //markup these notifications as read after rendering
	  user_notifications_markasread($notifications);		
		drupal_add_feed(url('user-notifications/feed'), $feed_title);
		
		//pass to stub theme function to allow overrides
    return '<div class="user-notifications-list-page">'. theme('user_notifications_notification_list', $account, $rows, TRUE) .'</div>';
	}
	else {
		//@TODO - pass this to a theme function
		$channel = array(
			'version' => '2.0', 
			'title' => $feed_title, 
			'link' => $base_url,  
			'language' => $language->language,
			'description' => $feed_title,
		);
		
		$output = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
		$output .= "<rss version=\"" . $channel["version"] . "\" xml:base=\"" . $base_url . "\">\n";
		$output .= format_rss_channel($channel['title'], $channel['link'], $channel['description'], $items, $channel['language']);
		$output .= "</rss>\n";
		print $output;		
	}
}
