<?php
// $Id$

/**
 * @file
 * Hooks and callback functions for rules.module integration.
 *
 * @Inspiration
 * Based heavily on privatemsg_rules.module
 */

/**
 * Implements hook_rules_action_info().
 *
 * @ingroup rules
 */
function user_notifications_rules_action_info() {
  return array(
    'rules_action_user_notifications_new' => array(
      'label' => t('Send a new notification to a user'),
      'arguments' => array(
        'recipient' => array('type' => 'string', 'label' => t('Recipient UID'), 'description' => t('The userID of the user(s) who will recieve the notfication. Use PHP evaluation or tokens to find the recipients UIDs. Common separate multiple values (ie. using tokens: [node:author-uid],2,45 OR using PHP: &lt;?php echo $node->uid; ?&gt;,&lt;?php echo $object->uid; ?&gt;,32')),
        'actor' => array('type' => 'string', 'label' => t('Actor UID'), 'description' => t("The userID of the user who triggered the notfication, the actor. Use PHP evaluation or tokens to find the actor UID.")),
        'subject' => array('type' => 'string', 'label' => t('Subject')),
        'body' => array('type' => 'string', 'label' => t('Body text'), 'long' => TRUE),
        'tag' => array('type' => 'string', 'label' => t('Tag'), 'description' => t('Unique identifier tag for this message. ie. status_like or node_comment')),
      ),
      'module' => 'User Notifications',
    ),
  );
}

/**
 * Helper function for sending a new message.
 * 
 * Loop through recipients 
 */
function rules_action_user_notifications_new($recipient_uids, $actor_uid, $subject, $body, $tag, $settings = array()) {
  //if not already an array, make one
	if (!is_array($recipient_uids)) {
		$recipient_uids = explode(',', $recipient_uids);
	}
	$recipients = user_notifications_recipients_load($recipient_uids);
	user_notifications_new_notification_wrapper($recipients, $actor_uid, $subject, $body, $tag, $settings);
}

/**
 * add tag to settings form
 * TODO: Allow body format to be set
 */
function rules_action_user_notifications_new_form($settings = array(), &$form) {
  user_notifications_common_rules_form($settings, $form);	
}